import {
  Body,
  Controller,
  Delete,
  Get,
  Patch,
  Path,
  Post,
  Request,
  Route,
  Security,
  Tags,
} from "tsoa";
import { AppDataSource } from "../database/data-source";
import {
  CreateProfileEmployeeTraining,
  ProfileTraining,
  UpdateProfileTraining,
} from "../entities/ProfileTraining";
import HttpSuccess from "../interfaces/http-success";
import HttpStatus from "../interfaces/http-status";
import HttpError from "../interfaces/http-error";
import { ProfileTrainingHistory } from "../entities/ProfileTrainingHistory";
import { RequestWithUser } from "../middlewares/user";
import { ProfileEmployee } from "../entities/ProfileEmployee";
import permission from "../interfaces/permission";
import { setLogDataDiff } from "../interfaces/utils";
@Route("api/v1/org/profile-employee/training")
@Tags("ProfileEmployeeTraining")
@Security("bearerAuth")
export class ProfileTrainingEmployeeController extends Controller {
  private profileEmployeeRepo = AppDataSource.getRepository(ProfileEmployee);
  private trainingRepo = AppDataSource.getRepository(ProfileTraining);
  private trainingHistoryRepo = AppDataSource.getRepository(ProfileTrainingHistory);

  @Get("user")
  public async getTrainingUser(@Request() request: { user: Record<string, any> }) {
    const profile = await this.profileEmployeeRepo.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    const record = await this.trainingRepo.find({
      where: { profileEmployeeId: profile.id, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    return new HttpSuccess(record);
  }

  @Get("{profileEmployeeId}")
  public async getTraining(@Path() profileEmployeeId: string, @Request() req: RequestWithUser) {
    let _workflow = await new permission().Workflow(req, profileEmployeeId, "SYS_REGISTRY_EMP");
    if (_workflow == false)
      await new permission().PermissionOrgUserGet(req, "SYS_REGISTRY_EMP", profileEmployeeId);
    const record = await this.trainingRepo.find({
      where: { profileEmployeeId, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    return new HttpSuccess(record);
  }

  @Get("admin/history/{trainingId}")
  public async trainingAdminHistory(@Path() trainingId: string, @Request() req: RequestWithUser) {
    const _record = await this.trainingRepo.findOneBy({ id: trainingId });
    if (_record) {
      let _workflow = await new permission().Workflow(req, trainingId, "SYS_REGISTRY_EMP");
      if (_workflow == false)
        await new permission().PermissionOrgUserGet(
          req,
          "SYS_REGISTRY_EMP",
          _record.profileEmployeeId,
        );
    }

    const record = await this.trainingHistoryRepo.find({
      where: {
        profileTrainingId: trainingId,
      },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Get("history/{trainingId}")
  public async trainingHistory(@Path() trainingId: string) {
    const record = await this.trainingHistoryRepo.find({
      where: {
        profileTrainingId: trainingId,
      },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Post()
  public async newTraining(
    @Request() req: RequestWithUser,
    @Body() body: CreateProfileEmployeeTraining,
  ) {
    if (!body.profileEmployeeId) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "กรุณากรอก profileEmployeeId");
    }

    const profile = await this.profileEmployeeRepo.findOneBy({ id: body.profileEmployeeId });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    await new permission().PermissionOrgUserUpdate(req, "SYS_REGISTRY_EMP", profile.id);
    const before = null;
    const data = new ProfileTraining();

    const meta = {
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };

    Object.assign(data, { ...body, ...meta });
    const history = new ProfileTrainingHistory();
    Object.assign(history, { ...data, id: undefined });

    await this.trainingRepo.save(data, { data: req });
    setLogDataDiff(req, { before, after: data });
    history.profileTrainingId = data.id;
    await this.trainingHistoryRepo.save(history, { data: req });

    return new HttpSuccess(data.id);
  }

  @Patch("{trainingId}")
  public async editTraining(
    @Request() req: RequestWithUser,
    @Body() body: UpdateProfileTraining,
    @Path() trainingId: string,
  ) {
    const record = await this.trainingRepo.findOneBy({ id: trainingId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    await new permission().PermissionOrgUserUpdate(
      req,
      "SYS_REGISTRY_EMP",
      record.profileEmployeeId,
    );
    const before = structuredClone(record);
    const history = new ProfileTrainingHistory();

    Object.assign(record, body);
    Object.assign(history, { ...record, id: undefined });

    history.profileTrainingId = trainingId;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = new Date();
    history.lastUpdateUserId = req.user.sub;
    history.lastUpdateFullName = req.user.name;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = new Date();
    history.lastUpdatedAt = new Date();

    await Promise.all([
      this.trainingRepo.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.trainingHistoryRepo.save(history, { data: req }),
    ]);

    return new HttpSuccess();
  }

  /**
   * API ลบข้อมูลการฝึกอบรม/ดูงาน
   * @summary API ลบข้อมูลการฝึกอบรม/ดูงาน
   * @param trainingId คีย์การฝึกอบรม/ดูงาน
   */
  @Patch("update-delete/{trainingId}")
  public async updateIsDeletedTraining(
    @Request() req: RequestWithUser,
    @Path() trainingId: string,
  ) {
    const record = await this.trainingRepo.findOneBy({ id: trainingId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    if (record.isDeleted === true) {
      return new HttpSuccess();
    }
    await new permission().PermissionOrgUserDelete(req, "SYS_REGISTRY_EMP", record.profileEmployeeId);
    const before = structuredClone(record);
    const history = new ProfileTrainingHistory();
    const now = new Date();
    record.isDeleted = true;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = now;

    Object.assign(history, { ...record, id: undefined });
    history.profileTrainingId = trainingId;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = now;

    await Promise.all([
      this.trainingRepo.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.trainingHistoryRepo.save(history, { data: req }),
    ]);

    return new HttpSuccess();
  }

  @Delete("{trainingId}")
  public async deleteTraining(@Path() trainingId: string, @Request() req: RequestWithUser) {
    const _record = await this.trainingRepo.findOneBy({ id: trainingId });
    if (_record) {
      await new permission().PermissionOrgUserDelete(
        req,
        "SYS_REGISTRY_EMP",
        _record.profileEmployeeId,
      );
    }

    await this.trainingHistoryRepo.delete({
      profileTrainingId: trainingId,
    });

    const result = await this.trainingRepo.delete({ id: trainingId });

    if (result.affected == undefined || result.affected <= 0) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }

    return new HttpSuccess();
  }
}
